import { VerificationError, apply_number, apply_string, apply_boolean, apply_void } from "./ts_base";
import AddValueResponse, { apply_AddValueResponse } from "./AddValueResponse";
import AddValueRequest, { apply_AddValueRequest } from "./AddValueRequest";
export type {
   AddValueResponse,
   AddValueRequest,
}
import { Service, ServiceProvider, getRandomID } from "./service_client";

export class TestService extends Service {
   constructor(provider: ServiceProvider){
      super(provider, "TestService");
   }
   AddValuesSingleParam(request: AddValueRequest): Promise<AddValueResponse> {
      return new Promise<AddValueResponse>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.AddValuesSingleParam",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         result = apply_AddValueResponse(result);
         return result;
      });
   }

   AddValuesMultipleParams(value1: number, value2: number): Promise<number> {
      return new Promise<number>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.AddValuesMultipleParams",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         result = apply_number(result);
         return result;
      });
   }

   ReturningVoid(param1: number): Promise<void> {
      return new Promise<void>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.ReturningVoid",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         result = apply_void(result);
         return result;
      });
   }

   OnEvent(param1: string): void {
      this._provider.sendMessage({
         jsonrpc: "2.0",
         method: "TestService.OnEvent",
         params: [...arguments]
      });
   }

   ThrowingError(): Promise<void> {
      return new Promise<void>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.ThrowingError",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         result = apply_void(result);
         return result;
      });
   }

   FunctionWithArrayAsParamAndReturn(values1: number[], values2: number[]): Promise<number[]> {
      return new Promise<number[]>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.FunctionWithArrayAsParamAndReturn",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         for(let i = 0; i < result.length; i++) {
            result[i] = apply_number(result[i]);
         }
         return result;
      });
   }

}